X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/bf06554599dc27e2029c073ce69088bc58cbe1d0..c9b10f2eb14ea64cf300438131ca05a02ce18069:/package/madwifi/files/lib/wifi/madwifi.sh?ds=inline

diff --git a/package/madwifi/files/lib/wifi/madwifi.sh b/package/madwifi/files/lib/wifi/madwifi.sh
index 13631818f..52086f04b 100755
--- a/package/madwifi/files/lib/wifi/madwifi.sh
+++ b/package/madwifi/files/lib/wifi/madwifi.sh
@@ -14,25 +14,24 @@ scan_atheros() {
 		
 		config_get mode "$vif" mode
 		case "$mode" in
-			adhoc|ahdemo|sta|ap)
+			adhoc|ahdemo|sta|ap|monitor)
 				append $mode "$vif"
 			;;
 			wds)
-				config_get addr "$vif" bssid
 				config_get ssid "$vif" ssid
-				[ -z "$addr" -a -n "$ssid" ] && {
-					config_set "$vif" wds 1
-					config_set "$vif" mode sta
-					mode="sta"
-					addr="$ssid"
-				}
+				[ -z "$ssid" ] && continue
+
+				config_set "$vif" wds 1
+				config_set "$vif" mode sta
+				mode="sta"
+				addr="$ssid"
 				${addr:+append $mode "$vif"}
 			;;
 			*) echo "$device($vif): Invalid mode, ignored."; continue;;
 		esac
 	done
 
-	case "${adhoc:+1}:${sta:+1}:${ap+1}" in
+	case "${adhoc:+1}:${sta:+1}:${ap:+1}" in
 		# valid mode combinations
 		1::) wds="";;
 		1::1);;
@@ -43,7 +42,7 @@ scan_atheros() {
 		*) echo "$device: Invalid mode combination in config"; return 1;;
 	esac
 
-	config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
+	config_set "$device" vifs "${sta:+$sta }${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${wds:+$wds }${monitor:+$monitor}"
 }
 
 
@@ -51,18 +50,14 @@ disable_atheros() (
 	local device="$1"
 
 	set_wifi_down "$device"
-	# kill all running hostapd and wpa_supplicant processes that
-	# are running on atheros vifs 
-	for pid in `pidof hostapd wpa_supplicant`; do
-		grep ath /proc/$pid/cmdline >/dev/null && \
-			kill $pid
-	done
 	
 	include /lib/network
 	cd /proc/sys/net
 	for dev in *; do
 		grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
-			ifconfig "$dev" down 
+			[ -f "/var/run/wifi-${dev}.pid" ] &&
+				kill "$(cat "/var/run/wifi-${dev}.pid")"
+			ifconfig "$dev" down
 			unbridge "$dev"
 			wlanconfig "$dev" destroy
 		}
@@ -71,17 +66,35 @@ disable_atheros() (
 )
 
 enable_atheros() {
+	local device="$1"
+	# Can only set the country code to one setting for the entire system. The last country code is the one that will be applied.
+	config_get country "$device" country
+	[ -z "$country" ] && country="0"
+	local cc="0"
+	[ -e /proc/sys/dev/$device/countrycode ] && cc="$(cat /proc/sys/dev/$device/countrycode)"
+	if [ ! "$cc" = "$country" ] ; then
+		rmmod ath_pci
+		insmod ath_pci countrycode=$country
+	fi
 	config_get channel "$device" channel
 	config_get vifs "$device" vifs
-	
+	config_get txpower "$device" txpower
+
+	[ auto = "$channel" ] && channel=0
+
 	local first=1
 	for vif in $vifs; do
+		local start_hostapd vif_txpower
 		nosbeacon=
 		config_get ifname "$vif" ifname
 		config_get enc "$vif" encryption
+		config_get eap_type "$vif" eap_type
 		config_get mode "$vif" mode
 		
-		[ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
+		case "$mode" in
+			sta) config_get nosbeacon "$device" nosbeacon;;
+			adhoc) config_get nosbeacon "$vif" sw_merge;;
+		esac
 		
 		config_get ifname "$vif" ifname
 		ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
@@ -91,30 +104,36 @@ enable_atheros() {
 		}
 		config_set "$vif" ifname "$ifname"
 
+		# only need to change freq band and channel on the first vif
+		config_get hwmode "$device" hwmode
+		[ -z "$hwmode" ] && config_get hwmode "$device" mode
+
+		pureg=0
+		case "$hwmode" in
+			*b) hwmode=11b;;
+			*bg) hwmode=11g;;
+			*g) hwmode=11g; pureg=1;;
+			*gdt) hwmode=11gdt;;
+			*a) hwmode=11a;;
+			*adt) hwmode=11adt;;
+			*ast) hwmode=11ast;;
+			*fh) hwmode=fh;;
+			*) hwmode=auto;;
+		esac
+		iwpriv "$ifname" mode "$hwmode"
+		iwpriv "$ifname" pureg "$pureg"
+
 		[ "$first" = 1 ] && {
-			# only need to change freq band and channel on the first vif
-			config_get agmode "$device" mode
-			pureg=0
-			case "$agmode" in
-				*b) agmode=11b;;
-				*bg) agmode=11g;;
-				*g) agmode=11g; pureg=1;;
-				*a) agmode=11a;;
-				*) agmode=auto;;
-			esac
-			iwconfig "$ifname" channel 0 >/dev/null 2>/dev/null 
-			ifconfig "$ifname" up
-			sleep 1
-			iwpriv "$ifname" mode "$agmode"
-			iwpriv "$ifname" pureg "$pureg"
 			iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
 		}
 	
 		config_get_bool hidden "$vif" hidden 0
 		iwpriv "$ifname" hide_ssid "$hidden"
 
-		config_get_bool ff "$vif" ff 0
-		iwpriv "$ifname" ff "$ff"
+		config_get ff "$vif" ff
+		if [ -n "$ff" ]; then
+			iwpriv "$ifname" ff "$ff"
+		fi
 
 		config_get wds "$vif" wds
 		case "$wds" in
@@ -123,7 +142,11 @@ enable_atheros() {
 		esac
 		iwpriv "$ifname" wds "$wds"
 
-		wpa=
+		[ "$mode" = ap -a "$wds" = 1 ] && {
+			config_get_bool wdssep "$vif" wdssep 1
+			[ -n "$wdssep" ] && iwpriv "$ifname" wdssep "$wdssep"
+		}
+
 		case "$enc" in
 			WEP|wep)
 				for idx in 1 2 3 4; do
@@ -137,16 +160,13 @@ enable_atheros() {
 					*) iwconfig "$ifname" enc "$key";;
 				esac
 			;;
-			PSK|psk|PSK2|psk2)
+			psk*|wpa*)
+				start_hostapd=1
 				config_get key "$vif" key
 			;;
 		esac
 
 		case "$mode" in
-			wds)
-				config_get addr "$vif" bssid
-				iwpriv "$ifname" wds_add "$addr"
-			;;
 			adhoc|ahdemo)
 				config_get addr "$vif" bssid
 				[ -z "$addr" ] || { 
@@ -156,46 +176,117 @@ enable_atheros() {
 		esac
 		config_get ssid "$vif" ssid
 
-		[ "$mode" = "sta" ] && {
-			config_get_bool bgscan "$vif" bgscan 0
-			iwpriv "$ifname" bgscan "$bgscan"
-		}
-
-		config_get_bool antdiv "$device" diversity 1
-		sysctl -w dev."$device".diversity="$antdiv" >&-
+		config_get_bool bgscan "$vif" bgscan
+		[ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
 
+		config_get_bool antdiv "$device" diversity
 		config_get antrx "$device" rxantenna
-		if [ -n "$antrx" ]; then
-			sysctl -w dev."$device".rxantenna="$antrx" >&-
-		fi
-
 		config_get anttx "$device" txantenna
-		if [ -n "$anttx" ]; then
-			sysctl -w dev."$device".txantenna="$anttx" >&-
+		config_get_bool softled "$device" softled 1
+
+		devname="$(cat /proc/sys/dev/$device/dev_name)"
+		antgpio=
+		case "$devname" in
+			NanoStation2) antgpio=7;;
+			NanoStation5) antgpio=1;;
+		esac
+		if [ -n "$antgpio" ]; then
+			softled=0
+			config_get antenna "$device" antenna
+			case "$antenna" in
+				external) antdiv=0; antrx=1; anttx=1 ;;
+				horizontal) antdiv=0; antrx=1; anttx=1 ;;
+				vertical) antdiv=0; antrx=2; anttx=2 ;;
+				auto) antdiv=1; antrx=0; anttx=0 ;;
+			esac
+			
+			[ -x "$(which gpioctl 2>/dev/null)" ] || antenna=
+			case "$antenna" in
+				horizontal|vertical|auto)
+					gpioctl "dirout" "$antgpio" >/dev/null 2>&1
+					gpioctl "set" "$antgpio" >/dev/null 2>&1
+				;;
+				external)
+					gpioctl "dirout" "$antgpio" >/dev/null 2>&1
+					gpioctl "clear" "$antgpio" >/dev/null 2>&1
+				;;
+			esac
 		fi
 
+		[ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
+		[ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
+		[ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
+		[ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
+
 		config_get distance "$device" distance
-		if [ -n "$distance" ]; then
-			athctrl -i "$device" -d "$distance" >&-
-		fi
+		[ -n "$distance" ] && athctrl -i "$device" -d "$distance" >&-
 
-		config_get txpwr "$vif" txpower
-		if [ -n "$txpwr" ]; then
-			iwconfig "$ifname" txpower "${txpwr%%.*}"
-		fi
+		config_get rate "$vif" rate
+		[ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
+
+		config_get mcast_rate "$vif" mcast_rate
+		[ -n "$mcast_rate" ] && iwpriv "$ifname" mcast_rate "${mcast_rate%%.*}"
 
 		config_get frag "$vif" frag
-		if [ -n "$frag" ]; then
-			iwconfig "$ifname" frag "${frag%%.*}"
-		fi
+		[ -n "$frag" ] && iwconfig "$ifname" frag "${frag%%.*}"
 
 		config_get rts "$vif" rts
-		if [ -n "$rts" ]; then
-			iwconfig "$ifname" rts "${rts%%.*}"
-		fi
+		[ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
+
+		config_get_bool comp "$vif" compression
+		[ -n "$comp" ] && iwpriv "$ifname" compression "$comp"
+
+		config_get_bool minrate "$vif" minrate
+		[ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
+
+		config_get_bool maxrate "$vif" maxrate
+		[ -n "$maxrate" ] && iwpriv "$ifname" maxrate "$maxrate"
+
+		config_get_bool burst "$vif" bursting
+		[ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
+
+		config_get_bool wmm "$vif" wmm
+		[ -n "$wmm" ] && iwpriv "$ifname" wmm "$wmm"
+
+		config_get_bool xr "$vif" xr
+		[ -n "$xr" ] && iwpriv "$ifname" xr "$xr"
+
+		config_get_bool ar "$vif" ar
+		[ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
+
+		config_get_bool turbo "$vif" turbo
+		[ -n "$turbo" ] && iwpriv "$ifname" turbo "$turbo"
+
+		config_get_bool doth "$vif" doth 0
+		[ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
+
+		config_get_bool probereq "$vif" probereq
+		[ -n "$probereq" ] && iwpriv "$ifname" probereq "$probereq"
+
+		config_get maclist "$vif" maclist
+		[ -n "$maclist" ] && {
+			# flush MAC list
+			iwpriv "$ifname" maccmd 3
+			for mac in $maclist; do
+				iwpriv "$ifname" addmac "$mac"
+			done
+		}
+
+		config_get macpolicy "$vif" macpolicy
+		case "$macpolicy" in
+			allow)
+				iwpriv "$ifname" maccmd 1
+			;;
+			deny)
+				iwpriv "$ifname" maccmd 2
+			;;
+			*)
+				# default deny policy if mac list exists
+				[ -n "$maclist" ] && iwpriv "$ifname" maccmd 2
+			;;
+		esac
 
 		ifconfig "$ifname" up
-		iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
 
 		local net_cfg bridge
 		net_cfg="$(find_net_config "$vif")"
@@ -204,16 +295,28 @@ enable_atheros() {
 			config_set "$vif" bridge "$bridge"
 			start_net "$ifname" "$net_cfg"
 		}
+		[ -n "$ssid" ] && iwconfig "$ifname" essid on
 		iwconfig "$ifname" essid "$ssid"
 		set_wifi_up "$vif" "$ifname"
+
+		# TXPower settings only work if device is up already
+		# while atheros hardware theoretically is capable of per-vif (even per-packet) txpower
+		# adjustment it does not work with the current atheros hal/madwifi driver
+
+		config_get vif_txpower "$vif" txpower
+		# use vif_txpower (from wifi-iface) instead of txpower (from wifi-device) if
+		# the latter doesn't exist
+		txpower="${txpower:-$vif_txpower}"
+		[ -z "$txpower" ] || iwconfig "$ifname" txpower "${txpower%%.*}"
+
 		case "$mode" in
 			ap)
 				config_get_bool isolate "$vif" isolate 0
 				iwpriv "$ifname" ap_bridge "$((isolate^1))"
 
-				if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
+				if [ -n "$start_hostapd" ] && eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
 					hostapd_setup_vif "$vif" madwifi || {
-						echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
+						echo "enable_atheros($device): Failed to set up hostapd for interface $ifname" >&2
 						# make sure this wifi interface won't accidentally stay open without encryption
 						ifconfig "$ifname" down
 						wlanconfig "$ifname" destroy
@@ -222,30 +325,14 @@ enable_atheros() {
 				fi
 			;;
 			wds|sta)
-				case "$enc" in 
-					PSK|psk|PSK2|psk2)
-						case "$enc" in
-							PSK|psk)
-								proto='proto=WPA';;
-							PSK2|psk2)
-								proto='proto=RSN';;
-						esac
-						cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
-ctrl_interface=/var/run/wpa_supplicant
-network={
-	scan_ssid=1
-	ssid="$ssid"
-	key_mgmt=WPA-PSK
-	$proto
-	psk="$key"
-}
-EOF
-					;;
-					WPA|wpa|WPA2|wpa2)
-						#add wpa_supplicant calls here
-					;;
-				esac
-				[ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -B -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+				if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
+					wpa_supplicant_setup_vif "$vif" madwifi || {
+						echo "enable_atheros($device): Failed to set up wpa_supplicant for interface $ifname" >&2
+						ifconfig "$ifname" down
+						wlanconfig "$ifname" destroy
+						continue
+					}
+				fi
 			;;
 		esac
 		first=0
@@ -258,12 +345,21 @@ detect_atheros() {
 	[ -d ath ] || return
 	for dev in $(ls -d wifi* 2>&-); do
 		config_get type "$dev" type
+		devname="$(cat /proc/sys/dev/$dev/dev_name)"
+		case "$devname" in
+			NanoStation*)
+				EXTRA_DEV="
+# Ubiquiti NanoStation features
+	option antenna	auto # (auto|horizontal|vertical|external)
+"
+			;;
+		esac
 		[ "$type" = atheros ] && return
 		cat <<EOF
 config wifi-device  $dev
 	option type     atheros
-	option channel  5
-
+	option channel  auto
+$EXTRA_DEV
 	# REMOVE THIS LINE TO ENABLE WIFI:
 	option disabled 1